Summary: XMPP client
Name: swift
Version: 3.0
Release: 0.12.rc2%{?dist}
Group: Applications/Internet
License: GPLv3
Source0: http://swift.im/downloads/releases/swift-3.0rc2/swift-3.0rc2.tar.gz
Patch0: swiften-libdirsuffix.patch
URL: http://swift.im/
Obsoletes: jabbim < 0.5.1-7
BuildRequires: scons
BuildRequires: qt5-qtbase-devel
BuildRequires: qt5-qtwebkit-devel
BuildRequires: qt5-qtmultimedia-devel
BuildRequires: qt5-qtx11extras-devel
BuildRequires: qt5-qtdeclarative-devel
BuildRequires: qt5-qttools
BuildRequires: qt5-qttools-common
BuildRequires: qt5-linguist
BuildRequires: openssl-devel
BuildRequires: expat-devel
BuildRequires: boost-devel
BuildRequires: libxslt
BuildRequires: zlib-devel
BuildRequires: docbook-dtds
BuildRequires: libidn-devel
BuildRequires: desktop-file-utils
BuildRequires: cppunit-devel
BuildRequires: avahi-devel

%description
Swift is an easy to setup and use Jabber/XMPP instant messaging chat
application.

# -------------------------------- swiften ---------------------------

%package -n swiften
Summary:    Cross-platform XMPP client/server library
Group:      Development/Libraries

%description -n swiften
Swiften is a robust, high-quality, standards-compliant, cross-platform,
and performant C++ library for implementing XMPP applications.


# ------------------------------ swiften-devel -----------------------

%package -n swiften-devel
Summary:        Cross-platform XMPP client/server library (development files)
Group:          Development/Libraries
Requires:        swiften%{?_isa} = %{version}-%{release}

%description -n swiften-devel
Swiften is a robust, high-quality, standards-compliant, cross-platform,
and performant C++ library for implementing XMPP applications.

%prep
%setup -q -n swift-3.0rc2
%patch0 -p1

# Remove 3rd party libraries.
%if 0%{?rhel} > 0 && 0%{?rhel} <= 6
# On EPEL6, boost/uuid/*.h are not included in system. I had discussion
# with boost maintainer and he does not want to add uuid there.
# It is not problem, because uuid is only header used during compilation
# and does not interfere with other system files.
find 3rdParty/Boost/src/boost/*|grep -v 'boost/uuid'|xargs rm -rf
find 3rdParty/Boost/src/libs -delete
find 3rdParty/Boost/src/tools -delete
%else
find 3rdParty/Boost/src -delete
%endif

find 3rdParty/SCons -delete
find 3rdParty/Expat/src -delete
find 3rdParty/LibIDN -delete
find 3rdParty/SQLite -delete
find 3rdParty/Lua -delete
find 3rdParty/ZLib -delete

find 3rdParty/LCov -delete
find 3rdParty/OpenSSL -delete
find 3rdParty/Snarl -delete
find 3rdParty/LibMiniUPnPc -delete
find 3rdParty/LibNATPMP -delete
find 3rdParty/Breakpad/src -delete
# Swift fails to build with our docbook, but it's used only to generate
# documentation at compile time, so it's not problem.
#find 3rdParty/DocBook -delete 

# HippoMocks  is needed just for unit tests and it's only one header
# so we're not deleting it for now
#find 3rdParty/HippoMocks -delete
# CPPUnit is used only for unit tests, enabling it for now
#find 3rdParty/CppUnit/src -delete

# echo 'qt="/usr"' > config.py
# echo 'linkflags="-lpthread -lX11 -lQtDBus"' >> config.py
# ccflags have to be a list, not string
echo 'ccflags="%{optflags} -fPIC".split(" ")' >> config.py

%build
%if 0%{?rhel} > 0 && 0%{?rhel} <= 6
scons V=1 3rdParty/Boost/uuid
%endif

# rpmlint warns about buildroot here, but it's needed to put proper paths in the "swiften-config" binary.
scons V=1 Swift Swiften swiften_dll=1 SWIFTEN_INSTALLDIR=%{buildroot}/usr SWIFTEN_LIBDIR=%{buildroot}/%{_libdir} %{?_smp_mflags}

%install
scons V=1 swiften_dll=1 SWIFTEN_INSTALLDIR=%{buildroot}/usr SWIFTEN_LIBDIR=%{buildroot}/%{_libdir} %{buildroot}/usr
install -p -D -m 755 Swift/QtUI/swift-im \
    %{buildroot}%{_bindir}/swift-im

install -p -m 644 -D Swift/resources/logo/logo-icon-32.xpm \
    %{buildroot}%{_datadir}/pixmaps/%{name}.xpm
install -p -m 644 -D Swift/resources/logo/logo-icon-128.png \
    %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/%{name}.png
install -p -m 644 -D Swift/resources/logo/logo-icon-16.png \
    %{buildroot}%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
install -p -m 644 -D Swift/resources/logo/logo-icon-22.png \
    %{buildroot}%{_datadir}/icons/hicolor/22x22/apps/%{name}.png
install -p -m 644 -D Swift/resources/logo/logo-icon-24.png \
    %{buildroot}%{_datadir}/icons/hicolor/24x24/apps/%{name}.png
install -p -m 644 -D Swift/resources/logo/logo-icon-32.xpm \
    %{buildroot}%{_datadir}/icons/hicolor/32x32/apps/%{name}.xpm
install -p -m 644 -D Swift/resources/logo/logo-icon-512.png \
    %{buildroot}%{_datadir}/icons/hicolor/512x512/apps/%{name}.png
install -p -m 644 -D Swift/resources/logo/logo-icon-64.png \
    %{buildroot}%{_datadir}/icons/hicolor/64x64/apps/%{name}.png

# menu
desktop-file-install \
--dir=%{buildroot}%{_datadir}/applications \
Swift/resources/swift.desktop

%check
LD_LIBRARY_PATH=./Swiften scons V=1 %{?_smp_mflags} test=unit QA

%post
touch --no-create %{_datadir}/icons/hicolor &> /dev/null || :

%postun
if [ $1 -eq 0 ] ; then
  touch --no-create %{_datadir}/icons/hicolor &> /dev/null
  gtk-update-icon-cache %{_datadir}/icons/hicolor &> /dev/null || :
fi

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &> /dev/null || :

%post -n swiften -p /sbin/ldconfig

%postun -n swiften -p /sbin/ldconfig

%files
%defattr(-, root, root,-)
%doc COPYING
%{_bindir}/swift-im
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.xpm
%{_datadir}/icons/hicolor/*/apps/%name.png
%{_datadir}/icons/hicolor/*/apps/%name.xpm

%files -n swiften
%defattr(-, root, root,-)
%{_libdir}/libSwiften.so.*

%files -n swiften-devel
%defattr(-,root,root,-)
%{_bindir}/swiften-config
%{_includedir}/Swiften
%{_libdir}/libSwiften.so

%changelog
* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0-0.12.rc2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0-0.11.rc2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue Jul 04 2017 Jonathan Wakely <jwakely@redhat.com> - 3.0-0.10.rc2
- Rebuilt for Boost 1.64

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0-0.9.rc2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Jan 27 2017 Jonathan Wakely <jwakely@redhat.com> - 3.0-0.8.rc2
- Rebuilt for Boost 1.63

* Tue May 17 2016 Jonathan Wakely <jwakely@redhat.com> - 3.0-0.7.rc2
- Rebuilt for linker errors in boost (#1331983)

* Fri Feb 12 2016 Jan Kaluza <jkaluza@redhat.com> - 3.0-0.6.rc2
- update to new 3.0 rc2 version

* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 3.0-0.5.beta2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sat Jan 16 2016 Jonathan Wakely <jwakely@redhat.com> - 3.0-0.4.beta2
- Rebuilt for Boost 1.60

* Thu Aug 27 2015 Jonathan Wakely <jwakely@redhat.com> - 3.0-0.3.beta2
- Rebuilt for Boost 1.59

* Wed Jul 29 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.2.beta2
- Rebuilt for https://fedoraproject.org/wiki/Changes/F23Boost159

* Fri Jul 24 2015 Jan Kaluza <jkaluza@redhat.com> - 2.0-15
- update to new 3.0 beta2 version to fix FTBFS

* Wed Jul 22 2015 David Tardon <dtardon@redhat.com> - 2.0-15
- rebuild for Boost 1.58

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat May 02 2015 Kalev Lember <kalevlember@gmail.com> - 2.0-13
- Rebuilt for GCC 5 C++11 ABI change

* Tue Jan 27 2015 Petr Machata <pmachata@redhat.com> - 2.0-12
- Rebuild for boost 1.57.0
- Add -DBOOST_NEXT_PRIOR_HPP_INCLUDED to qt4-moc flags
- Include boost/optional/optional_io.hpp instead of boost/optional.hpp
  in many places (both changes in swift-boost-1.57.patch)

* Mon Aug 18 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri May 23 2014 Petr Machata <pmachata@redhat.com> - 2.0-9
- Rebuild for boost 1.55.0

* Fri May 23 2014 David Tardon <dtardon@redhat.com> - 2.0-8
- rebuild for boost 1.55.0

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Jul 27 2013 pmachata@redhat.com - 2.0-6
- Rebuild for boost 1.54.0

* Mon Mar 11 2013 Jan Kaluza <jkaluza@redhat.com> - 2.0-5
- fix #912374 - obsoletes Jabbim client

* Wed Feb 27 2013 Jan Kaluza <jkaluza@redhat.com> - 2.0-4
- fix #913841 - include boost header to find locks

* Sat Feb 09 2013 Denis Arnaud <denis.arnaud_fedora@m4x.org> - 2.0-3
- Rebuild for Boost-1.53.0

* Mon Jan 21 2013 Jan Kaluza <jkaluza@redhat.com> - 2.0-2
- install icons in all sizes

* Thu Jan 03 2013 Jan Kaluza <jkaluza@redhat.com> - 2.0-1
- update to new upstream version 2.0

* Tue Oct 09 2012 Jan Kaluza <jkaluza@redhat.com> - 2.0-0.3.beta2
- update to new upstream version 2.0-beta2
- fix #857900 - swift binary renamed to swift-im

* Fri Aug 17 2012 Jan Kaluza <jkaluza@redhat.com> - 2.0-0.2.beta1
- fix building with new boost filesystem

* Thu Aug 01 2012 Jan Kaluza <jkaluza@redhat.com> - 2.0-0.1.beta1
- Update to new upstream version
- Added swiften library

* Mon Jul 23 2012 Jan Kaluza <jkaluza@redhat.com> - 1.0-10
- fixed boost::TIME_UTC macro expansion

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Feb 28 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-8
- Rebuilt for c++ ABI breakage

* Tue Jan 10 2012 Jan Kaluza <jkaluza@redhat.com> - 1.0-7
- fix building in rawhide

* Tue Nov 22 2011 Jan Kaluza <jkaluza@redhat.com> - 1.0-6
- hack moc-qt4 execution to not parse boost headers

* Tue Nov 22 2011 Jan Kaluza <jkaluza@redhat.com> - 1.0-5
- rebuild for new boost

* Mon Jul 25 2011 Jan Kaluza <jkaluza@redhat.com> - 1.0-4
- rebuild for new boost

* Wed May 25 2011 Jan Kaluza <jkaluza@redhat.com> - 1.0-3
- fix #706719 - fixed another crash during login

* Tue Apr 26 2011 Jan Kaluza <jkaluza@redhat.com> - 1.0-2
- fix #697832 - fixed crash during login

* Tue Apr 19 2011 Jan Kaluza <jkaluza@redhat.com> - 1.0-1
- update to new upstream version 1.0

* Wed Apr 06 2011 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.11.beta9
- rebuild for new boost

* Tue Mar 15 2011 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.10.beta9
- update to new upstream version 1.0-beta9

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-0.9.beta8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Feb 06 2011 Thomas Spura <tomspur@fedoraproject.org> - 1.0-0.8.beta8
- rebuild for new boost

* Wed Nov 10 2010 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.7.beta8
- update to new upstream version 1.0-beta8

* Tue Oct 19 2010 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.6.beta7
- update to new upstream version 1.0-beta7

* Mon Aug 30 2010 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.5.beta6
- update to new upstream version 1.0-beta6

* Tue Aug 10 2010 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.4.beta5
- build with avahi-devel to get DNSSD Support

* Wed Aug 04 2010 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.3.beta5
- build with optflags
- preserve swift.xpm timestamp
- fixed license and install COPYING file
- fixed Changelog entries

* Wed Jul 28 2010 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.2.beta5
- delete all unused bundled libraries
- don't use deprecated BuildRoot tag
- swift.xpm replaced by icon from swift tarball

* Wed Jul 28 2010 Jan Kaluza <jkaluza@redhat.com> - 1.0-0.1.beta5
- created this SPEC file
